
-- 'Shooter 1945 based on a tutorial
-- 'by Asterios Gkoutmas
-- 'for the NaaLaa language
-- 'ported to EGSL by M. Mangold

-- 'By the way: the highlighting of the comments only works with a trick:
-- 'Start a Lua comment as usual with "--" but then add a "'" which is a BASIC comment
-- 'The TSynAnySyn component unfortunately doesn't recognize Lua comments ...

-- 'OUR MENUSCREEN AS A FUNCTION
function menuscreen ()
mouseshow()
xlogo=0
ylogo=480-imageheight(title)
direction=1
backcolor (0,0,95)
bn=1
bq=1
repeat
      button=mouseb()
      key=getkey()
      if keystate (102) then
         togglefullscreen()
      end
      cls()
      color (0,0,0)
      drawtext (222,282,"By Markus Mangold 2010")
      drawtext (132,302,"Thanks to Asterios Gkoutmas for the tutorial.")
      color (255,255,0)
      drawtext (221,280,"By Markus Mangold 2010")
      drawtext (130,300,"Thanks to Asterios Gkoutmas for the tutorial.")
      drawtext (500,10,"HISCORE: "..hiscore)
      putimage ((640/2)-(imagewidth(biglogo)/2),5,biglogo)
      putimage (xlogo,ylogo,title)
      putimage (260,180,but_new[bn])
      putimage (260,220,but_quit[bq])
      if mousezone (260,180,260+120,180+20) then
         bn=2
      else
          bn=1
      end
      if mousezone (260,200,260+120,220+20) then
         bq=2
      else
          bq=1
      end
      if (bq==2) and (button==1) or (key==27) then
         closewindow()
         os.exit()
      end
      xlogo=xlogo+direction
      if xlogo >= (640-193) then
         direction=-1
      end
      if xlogo <=0 then
         direction=1
      end
      redraw()
      wait (timeleft())
until (bn==2) and (button==1)
end        -- 'OF FUNCTION

-- 'MAIN PRG STARTS HERE
openwindow (640,480,32,"Shooter 1945")
setframetimer (60)
music =loadmusic ("data/shooter1945/lizard.mod")
playmusic (music, 255, -1)

snd_explo=loadsound("data/shooter1945/explosion.wav")
snd_bigexplo=loadsound("data/shooter1945/explosion2.wav")
snd_missile=loadsound("data/shooter1945/missile.wav")
snd_gunfire=loadsound("data/shooter1945/gunshot.wav")


plane={}
enemy={}
explosion={}
bigexplosion={}
island={}
superenemy={}
colourkey (0,67,171)
plane[1]=loadimage ("data/shooter1945/plane1.bmp")
plane[2]=loadimage ("data/shooter1945/plane2.bmp")
plane[3]=loadimage ("data/shooter1945/plane3.bmp")
bullet=loadimage ("data/shooter1945/bullet.bmp")
enemy[1]=loadimage ("data/shooter1945/enemy1.bmp")
enemy[2]=loadimage ("data/shooter1945/enemy2.bmp")
enemy[3]=loadimage ("data/shooter1945/enemy3.bmp")
for i=1,6 do
   explosion[i]=loadimage ("data/shooter1945/explosion"..i..".bmp")
end
for i=1,6 do
   bigexplosion[i]=loadimage ("data/shooter1945/bigexplosion"..i..".bmp")
end
for i=1,3 do
   island[i]=loadimage ("data/shooter1945/island"..i..".bmp")
end
for i=1,3 do
   superenemy[i]=loadimage ("data/shooter1945/superenemy"..i..".bmp")
end
enemybullet=loadimage ("data/shooter1945/enemybullet.bmp")
lifeimage=loadimage("data/shooter1945/life.bmp")
logo=loadimage("data/shooter1945/logo.bmp")
colourkey(0,0,0)
title=loadimage("data/shooter1945/madewithegsldarktiny.png")
nocolourkey()

seatile=loadimage ("data/shooter1945/sea.bmp")
menu=loadimage ("data/shooter1945/menu.bmp")
arrow=loadimage ("data/shooter1945/arrow.bmp")
biglogo=loadimage ("data/shooter1945/big logo.bmp")
but_new={}
but_quit={}
colourkey (0,0,0)
but_new[1]=loadimage ("data/shooter1945/button1up.png")
but_new[2]=loadimage ("data/shooter1945/button1over.png")
but_quit[1]=loadimage ("data/shooter1945/button2up.png")
but_quit[2]=loadimage ("data/shooter1945/button2over.png")
for i=0,20  do
    for j=0,15 do
    putimage (i*32,j*32,seatile)
    end
end
background=grabimage(0,0,640,480)    --' grab the background as whole
hiscore=0
cls()
repeat
 endkey=getkey()
menuscreen()
wait (1000)
mousehide()

-- 'INITIALIZING VARIABLES
enemyX={}
enemyY={}
superenemyX={}
superenemyY={}
decision={}
enemybulletX={}
enemybulletY={}
enemyshot={}
enemyshot[0]=0
enemyshot[1]=0
islandX={}
islandY={}
islandImage={}
backoffset=0
frame=1
explo_frame=1
speed=2
planex=320
planey=480-128
CURSUP=273
CURSDOWN=274
CURSLEFT=276
CURSRIGHT=275
LCTRL=306
bulletx=-30
bullety=-30
shot=0
explox=-30
exploy=-30
score=0
lives=3
health=100
bullseye=1
shots_fired=1
bigexplo_frame=1
bigexplox=-70
bigexploy=-70
bigexploactive=0

-- 'POSITIONS OF ENEMIES
for i=0,4 do
    repeat
    enemyX[i]=int(rnd()*608)+1
    until enemyX[i]>32
    enemyY[i]=-(int(rnd()*100)+1)-32
end
for i=0,1 do
   repeat
    superenemyX[i]=int(rnd()*608)+1
    until superenemyX[i]>32
    superenemyY[i]=-(int(rnd()*100)+1)-32
    enemybulletX[i]=superenemyX[i]+17
    enemybulletY[i]=superenemyY[i]+17
end

-- 'POSITIONS OF THE ISLANDS
for i=0,2 do
    repeat
    islandX[i]=int(rnd()*608)+1
    until islandX[i]>32
    islandY[i]=-(int(rnd()*100)+1)-96
    islandImage[i]=int(rnd()*3)+1
end

-- 'GAME LOOP STARTS HERE
pausemusic()
repeat

  cls()
  putimage (0,0+backoffset,background)
  putimage (0,backoffset-480,background)
  key=getkey()
  if keystate(CURSUP) then
    planey=planey-speed
 end
 if keystate(CURSDOWN) then
    planey=planey+speed
 end
 if keystate(CURSRIGHT) then
    planex=planex+speed
 end
 if keystate(CURSLEFT) then
    planex=planex-speed
 end
 if keystate(LCTRL) and (shot==0) then
    bulletx=planex+17
    bullety=planey+5
    shot=1
    shots_fired=shots_fired+1
    playsound (snd_missile,75)
 end

 -- 'MOVING ENEMIES
 for z=0,4 do
     if enemyY[z] > 480 then
     repeat
           enemyX[z]=int(rnd()*608)+1
           until enemyX[z]>32
           enemyY[z]=-(int(rnd()*100)+1)-32
     else
           enemyY[z]=enemyY[z]+speed
     end
 end
 for z=0,1 do
     if superenemyY[z] > 480 then
     repeat
           superenemyX[z]=int(rnd()*608)+1
           until superenemyX[z]>32
           superenemyY[z]=-(int(rnd()*100)+1)-32
     else
           superenemyY[z]=superenemyY[z]+speed
     end
 end

 -- 'MOVING THE ISLANDS
 for z=0,2 do
     if islandY[z]>480 then
      repeat
       islandX[z]=int(rnd()*536)+1
      until islandX[z]>32
       islandY[z]=-(int(rnd()*300)+1)
            islandImage[z]=int(rnd()*3)+1
     else
         islandY[z]=islandY[z]+1
     end
  end

 -- 'COLLISION CHECKING
 for t=0,4 do
     if boxcoll (planex,planey,imagewidth(plane[1]),imageheight(plane[1]),enemyX[t],enemyY[t],imagewidth(enemy[1]),imageheight(enemy[1])) then
     explox=enemyX[t]
     exploy=enemyY[t]
     explo_frame=1
     playsound (snd_explo,255)
     repeat
           enemyX[t]=int(rnd()*608)+1
     until enemyX[t]>32
           enemyY[t]=-(int(rnd()*100)+1)-32
           health=health-25
           if health <= 0 then
              bigexploactive=1
              bigexplox=planex
              bigexploy=planey
              planex=-70
              planey=-70
              playsound (snd_bigexplo,255)
           end
     elseif boxcoll (bulletx,bullety,imagewidth(bullet),imageheight(bullet),enemyX[t],enemyY[t],imagewidth(enemy[1]),imageheight(enemy[1])) then
     explox=enemyX[t]
     exploy=enemyY[t]
     explo_frame=1
     playsound (snd_explo,255)
     repeat
           enemyX[t]=int(rnd()*608)+1
     until enemyX[t]>32
           enemyY[t]=-(int(rnd()*100)+1)-32
           bulletx=-30
           bullety=-30
           score=score+50
           bullseye=bullseye+1
     end
  end
 for t=0,1 do
     if boxcoll (planex,planey,imagewidth(plane[1]),imageheight(plane[1]),superenemyX[t],superenemyY[t],imagewidth(superenemy[1]),imageheight(superenemy[1])) then
     explox=superenemyX[t]
     exploy=superenemyY[t]
     explo_frame=1
     playsound (snd_explo,255)
     repeat
           superenemyX[t]=int(rnd()*608)+1
     until superenemyX[t]>32
           superenemyY[t]=-(int(rnd()*100)+1)-32
           health=health-25
           if health <= 0 then
              bigexploactive=1
              bigexplox=planex
              bigexploy=planey
              planex=-70
              planey=-70
              playsound (snd_bigexplo,255)
           end
     elseif boxcoll (bulletx,bullety,imagewidth(bullet),imageheight(bullet),superenemyX[t],superenemyY[t],imagewidth(superenemy[1]),imageheight(superenemy[1])) then
     explox=superenemyX[t]
     exploy=superenemyY[t]
     explo_frame=1
     playsound (snd_explo,255)
     repeat
           superenemyX[t]=int(rnd()*608)+1
     until superenemyX[t]>32
           superenemyY[t]=-(int(rnd()*100)+1)-32
           bulletx=-30
           bullety=-30
           score=score+100
           bullseye=bullseye+1
     end
  end
  for t=0,1 do
      if boxcoll (planex,planey,imagewidth(plane[1]),imageheight(plane[1]),enemybulletX[t],enemybulletY[t],imagewidth(enemybullet),imageheight(enemybullet)) then
         explox=enemybulletX[t]
         exploy=enemybulletY[t]
         explo_frame=1
         playsound (snd_explo,255)
         health=health-10
         if health <=0 then
              bigexploactive=1
              bigexplox=planex
              bigexploy=planey
              planex=-70
              planey=-70
             playsound (snd_bigexplo,255)
           end
          enemybulletX[t]=superenemyX[t]+7
          enemybulletY[t]=superenemyY[t]+14
          enemyshot[t]=0
     end
  end

 -- 'DISPLAYING PLANE IN SCREEN
 if (planex <0) and (bigexploactive==0) then
    planex=0
 end
 if planey <0 and (bigexploactive==0) then
    planey=0
 end
 if planex+imagewidth(plane[int(frame)])>640 then
    planex=640-imagewidth(plane[int(frame)])
 end
 if planey+imageheight(plane[int(frame)])>480-63 then
    planey=480-imageheight(plane[int(frame)])-63
 end
 if bullety >0 then
    bullety=bullety-speed*2
 else

     bulletx=-30
     bullety=-30
     shot=0
 end
 for o=0,2 do
 putimage (islandX[o],islandY[o],island[islandImage[o]])
 end
 putimage (bulletx,bullety,bullet)
 putimage (planex,planey,plane[int(frame)])
 for x=0,4 do
    putimage (enemyX[x],enemyY[x],enemy[int(frame)])
 end
 for i=0,1 do
     if enemyshot[i]==0 then
        decision[i]=int(rnd()*50)+1
     end
     if decision[i]==9 then
        if enemybulletY[i] <=superenemyY[i]+15 then
           playsound (snd_gunfire,15)
        end

        if enemybulletY[i]< 480 then
           enemybulletY[i]=enemybulletY[i]+3
           enemyshot[i]=1

         else
          enemybulletX[i]=superenemyX[i]+7
          enemybulletY[i]=superenemyY[i]+14
          enemyshot[i]=0
          end
     else
         enemybulletX[i]=superenemyX[i]+7
          enemybulletY[i]=superenemyY[i]+14
          enemyshot[i]=0
      end
      putimage (enemybulletX[i],enemybulletY[i],enemybullet)
  end
  for x=0,1 do
      putimage (superenemyX[x],superenemyY[x],superenemy[int(frame)])
  end

 -- 'EXPLOSION
  if explo_frame > 6 then
  explo_frame=1
  explox=-30
  exploy=-30
 end
 putimage (explox,exploy,explosion[int(explo_frame)])
 explo_frame=explo_frame+0.3
 frame=frame+0.2
 if frame > 3 then
    frame=1
 end
  backoffset=backoffset +1
  if backoffset >480 then
     backoffset=0
  end

-- 'BIG EXPLOSION
if bigexploactive==1 then
   for s=0,4 do
   repeat
      enemyX[s]=int(rnd()*608)+1
   until enemyX[s]>32
      enemyY[s]=-(int(rnd()*100)+1)-32
   end
end
if (bigexplox>0) and (bigexplox<640) then
   bigexplo_frame=bigexplo_frame+0.3
end
if bigexplo_frame>6 then
   bigexploactive=0
   bigexplo_frame=1
   bigexplox=-90
   bigexploy=-90
   lives=lives-1
   planex=320
   planey=480-128
   health=100
end
putimage (bigexplox,bigexploy,bigexplosion[int(bigexplo_frame)])
if score >= hiscore then
   hiscore=score
end

-- 'INFORMATION PANEL
  color (220,220,220)
  fillbox (0,480-63,640,480)
  color (180,180,180)
  fillbox (5,480-58,635,480)
  color (120,120,120)
  fillbox (5,480-58,630,480)
  color (0,0,255)
  box (6,480-22,108,480-10)
  color (0,0,0)
  fillbox (7,480-21,107,480-11)
  for z=1,10 do
      if health>75 then
      color (0,255,0)
      elseif health>25 then
      color (255,255,0)
      else
      color (255,0,0)
      end
      line (7,480-22+z,7+health,480-22+z)
  end
  color (0,0,0)
  drawtext (5,480-58,"Score: "..score)
  drawtext (5,480-48,"Hiscore: "..hiscore)
  drawtext (5,480-38,"Accuracy: "..int(bullseye/shots_fired*100.0).."%")
  for i=1,lives do
    putimage(120+i*32,480-32,lifeimage)
  end
  putimage (640-imagewidth(logo),480-58,logo)
 if keystate (112) then
   color (00,00,00)
   for i=0,480,2 do
       line (0,i,640,i)
   end
   color (255,255,0)
   drawtext (200,220,"PAUSE - Press any key to go on")
   redraw()
  inkey()
   end
 if keystate (102) then
      togglefullscreen()
  end

 redraw()
 wait (timeleft())
 until (key==27) or (lives<0)
 color (255,255,0)
 drawtext (200,225,"Game Over! - Press any key to go on")
 redraw()
 inkey()
  resumemusic()
until (endkey==27)
closewindow()

