-- brawlin
-- 2013 OSGELD
-- for ludemdare 27

-- window
nocolourkey()
openwindow (800,600,32," brawling for LD 27 :: 2013 Osgeld")

bounds = {}
bounds.x1  = 0
bounds.x2  = 736
bounds.y1  = 80
bounds.y2  = 470

bounds.box = {}
bounds.box.size  = 16
bounds.box.x     = 23
bounds.box.y     = 36
bounds.box.fsize = 8
bounds.box.fx	 = 10
bounds.box.fy    = 50

Eoldhittime = 0
Eoldhit     = 0
oldhittime  = 0
oldhit      = 0
oldtime     = 0
state       = "start"
oldanim     = "left"

-- load assets (EGSL is having issues with this stuff being in multidimentional tables) 
bg = loadimage("data/barwlin/bg.png")

player = {}
player.LwalkIMG   = loadimage("data/barwlin/walk.png")
player.LkickIMG   = loadimage("data/barwlin/kick.png")
player.LpunchIMG  = loadimage("data/barwlin/punch.png")
player.RwalkIMG   = fliphorizontal(player.LwalkIMG)
player.RkickIMG   = fliphorizontal(player.LkickIMG)
player.RpunchIMG  = fliphorizontal(player.LpunchIMG)
player.LwalkANI   = spriteanimation(player.LwalkIMG,1,2,7,1)
player.RwalkANI   = spriteanimation(player.RwalkIMG,1,2,7,1)  
player.LkickANI   = spriteanimation(player.LkickIMG,1,2,3,1) 
player.RkickANI   = spriteanimation(player.RkickIMG,1,2,3,1)
player.LpunchANI  = spriteanimation(player.LpunchIMG,1,2,5,1) 
player.RpunchANI  = spriteanimation(player.RpunchIMG,1,2,5,1)
player.x		  = 400
player.y          = 300
player.health     = 100


eny = {}
eny.LwalkIMG   = loadimage("data/barwlin/ewalk.png")
eny.LkickIMG   = loadimage("data/barwlin/ekick.png")
eny.LpunchIMG  = loadimage("data/barwlin/epunch.png")
eny.RwalkIMG   = fliphorizontal(eny.LwalkIMG)
eny.RkickIMG   = fliphorizontal(eny.LkickIMG)
eny.RpunchIMG  = fliphorizontal(eny.LpunchIMG)
eny.LwalkANI   = spriteanimation(eny.LwalkIMG,1,2,7,1)
eny.RwalkANI   = spriteanimation(eny.RwalkIMG,1,2,7,1)  
eny.LkickANI   = spriteanimation(eny.LkickIMG,1,2,3,1) 
eny.RkickANI   = spriteanimation(eny.RkickIMG,1,2,3,1)
eny.LpunchANI  = spriteanimation(eny.LpunchIMG,1,2,3,1) 
eny.RpunchANI  = spriteanimation(eny.RpunchIMG,1,2,3,1)
	
sound = {}
sound.hits  = loadsound("data/barwlin/playerhits.wav")
sound.hurts = loadsound("data/barwlin/playergetshit.wav")
sound.music = loadmusic("data/barwlin/blood.it")

-- table of enemies on screen 
-- x,y,health,directiony,directionx,action
baddies ={}

-- control
control =
{
	escape = 027,
	up     = 273,
	down   = 274,
	left   = 276,
	right  = 275,
	punch  = 032,
	kick   = 100,	
}

-- player control
control.player = function()
	if player.health == 0 then
		playsound(sound.hits, 50, 1, 0)
		createparticles(player.x ,player.y,1000,250,math.random(64,128),0,0)
		state = "gameover"
	end
	direction = ""
	if keystate(control.punch) then 
		direction = "punch" 
	else
		if keystate(control.left) == true then 
			direction = "left"
		elseif keystate(control.right) == true then direction = "right"
		end
	
		if keystate(control.up) == true then direction = "up"
		elseif keystate(control.down) == true then direction = "down"
		end
	end

	if direction == "left" and player.x > bounds.x1 then 
		player.x = player.x - 3
		player.sprite = spriteframe(player.LwalkANI)
		oldanim = direction
		
	elseif  direction == "right" and player.x < bounds.x2 then 
		player.x = player.x + 3
		player.sprite = spriteframe(player.RwalkANI)
		oldanim = direction
	end
	
	if direction == "up" and player.y > bounds.y1 then 
		player.y = player.y - 3
	elseif  direction == "down" and player.y < bounds.y2 then 
		player.y = player.y + 3
	end
	
	if oldanim == "left" then player.sprite = spriteframe(player.LwalkANI)
	else player.sprite = spriteframe(player.RwalkANI)
	end
	
	if direction == "punch" then 
		if oldanim == "left" then
			player.sprite = spriteframe(player.LpunchANI)
		else
			player.sprite = spriteframe(player.RpunchANI)
		end	
	end
	
	for e = 1, #baddies do
		-- collision box for player
		x1 = player.x 
		y1 = player.y 

	
		w1 = 64
		h1 = 128
		x2 = baddies[e][1]
		y2 = baddies[e][2]
		w2 = 64
		h2 = 128
		
		--box(baddies[e][1], baddies[e][2], baddies[e][1] + 64, baddies[e][2] + 128)
		--box(player.x, player.y, player.x + 64, player.y + 128)
		
		if boxcoll(x1,y1,w1,h1,x2,y2,w2,h2) and direction == "punch" then
			if baddies[e][1] > player.x  then baddies[e][5] = 2
			elseif baddies[e][1] < player.x then baddies[e][5] = 1
			end
			
			if baddies[e][1] > player.x + 10 then baddies[e][1] = baddies[e][1] - 1
			elseif baddies[e][1] < player.x  -10 then baddies[e][1] = baddies[e][1] + 1
			end
			
			if oldhit == 0 then
				createparticles (baddies[e][1] + (bounds.box.x + 8),baddies[e][2] + (bounds.box.y + 8),50,50,math.random(64,128),0,0)
				playsound(sound.hurts, 100, 1, 0)
				if baddies[e][3] > 0 then 
					baddies[e][3] = baddies[e][3] - 10
				end
				
				oldhit= 1
				oldhittime = timerticks()
			end
		else baddies[e][6] = "walking"
		end
	end
	
	if (timerticks() - oldhittime > 375)then
		oldhit = 0
	end
end

control.eny = function()
	--update enemies
	
	-- clean up dead bodies
	kill = {}
	for e = 1, #baddies do
		if baddies[e][3] == 0 then
			table.insert(kill, e)
		end
	end
	for k = 1, #kill do
		createparticles (baddies[kill[k]][1] + (bounds.box.x + 8),baddies[kill[k]][2] + (bounds.box.y + 8),1000,250,math.random(64,128),0,0)
		table.remove(baddies, kill[k])
		if player.health < 100 then 
			player.health = player.health + 5
		end
		playsound(sound.hits, 50, 1, 0)
	end
	
	for e = 1, #baddies do
		-- collision box for baddies
		if baddies[e][5] == 2 then
			 x1 = baddies[e][1] + bounds.box.fx
			 y1 = baddies[e][2] + bounds.box.fy
		else
			x1 = baddies[e][1] + (55 - bounds.box.fx)
			y1 = baddies[e][2] +  bounds.box.fy
		end
		
		w1 = bounds.box.fsize
		h1 = bounds.box.fsize
		-- collision box for player
		x2 = player.x + bounds.box.x
		y2 = player.y + bounds.box.y
		w2 = bounds.box.size
		h2 = bounds.box.size
		
		if baddies[e][6] == "walking" then
			if boxcoll(x1,y1,w1,h1,x2,y2,w2,h2) then
				baddies[e][6] = "punch"
			end
		end
		
	
		if baddies[e][6] == "walking" then
			if baddies[e][5] == 1 and baddies[e][1] > bounds.x1 then
				if baddies[e][1] < bounds.x2 then
					baddies[e][1] = baddies[e][1] + 1
				else 
					baddies[e][1] = baddies[e][1] - 1
					baddies[e][5] = 2
				end
			
				elseif baddies[e][5] == 2 and baddies[e][1] < bounds.x2 then
				if baddies[e][1] > bounds.x1 then
					baddies[e][1] = baddies[e][1] - 1
				else 
					baddies[e][1] = baddies[e][1] + 1
					baddies[e][5] = 1
				end
			end
		
			if baddies[e][4] == 1 and baddies[e][2] > bounds.y1 then
				if baddies[e][2] < bounds.y2 then
					baddies[e][2] = baddies[e][2] + 1
				else 
					baddies[e][2] = baddies[e][2] - 1
					baddies[e][4] = 2
				end
			
			elseif baddies[e][4] == 2 and baddies[e][2] < bounds.y2 then
				if baddies[e][2] > bounds.y1 then
					baddies[e][2] = baddies[e][2] - 1
				else 
					baddies[e][2] = baddies[e][2] + 1
					baddies[e][4] = 1
				end
			end

		end
	end
	
	if (timerticks() - Eoldhittime > 375)then
		Eoldhit = 0
	end
end

-- add enemies
eny.add = function()
	for e = 1, 3 do
		directiony = math.random(1, 2)
		directionx = math.random(1, 2)
		if directionx == 1 then 
			x = 64
		else 
			x = 730
		end
		
		y = bounds.y1 + (e * 64) 
		table.insert(baddies, {x, y, 100, directiony ,directionx, "walking"})
	end
end

Zorder = function()
	drawOrder = {}
	for e = 1, #baddies do
		table.insert(drawOrder, {baddies[e][2], e})
	end
	table.insert(drawOrder, {player.y, 0})
	
	function compare(a,b)
		return a[1] < b[1]
	end
	table.sort(drawOrder, compare)
end

drawActors = function()
	for d = 1, #drawOrder do
		if drawOrder[d][2] == 0 then
			if state == "playing" then
				drawtext(player.x, player.y, player.health)
				putimage(player.x, player.y, player.sprite)
			end
			--freeimage(player.sprite) -- causes a crash... whatever
		else
			if baddies[drawOrder[d][2]][6] == "walking" then	
				if baddies[drawOrder[d][2]][5] == 2 then			
					eny.sprite = spriteframe(eny.LwalkANI)
				else
					eny.sprite = spriteframe(eny.RwalkANI)
				end
			else
				if baddies[drawOrder[d][2]][5] == 2 then			
					eny.sprite = spriteframe(eny.LpunchANI)
				else
					eny.sprite = spriteframe(eny.RpunchANI)
				end
				if Eoldhit == 0 then
					createparticles (player.x + (bounds.box.x + 8),player.y + (bounds.box.y + 8),50,50,math.random(64,128),0,0)
					playsound(sound.hurts, 100, 1, 0)
					player.health = player.health - 1
					Eoldhit= 1
					Eoldhittime = timerticks()
				end
			end
			drawtext(baddies[drawOrder[d][2]][1],baddies[drawOrder[d][2]][2],baddies[drawOrder[d][2]][3])
			putimage(baddies[drawOrder[d][2]][1],baddies[drawOrder[d][2]][2], eny.sprite)
			freeimage(eny.sprite)				
		end
	end
end

tensec = function()
	if (timerticks() - oldtime > 10000)then
		oldtime = timerticks()
		eny.add()
	end	
end

-- lets get things started 
eny.add()
setparticletype("fillcircle") 
setparticlesize(1,"random")
playmusic(sound.music,100,-1)
colourkey(240,0,255) -- alpha key

-- main loop
while (getkey() ~= control.escape)  do
	if state == "start" then
		drawtext(0, 100, "Brawlin")
		drawtext(0, 150, "2013 Osgeld for LD 27")
		drawtext(0, 200, "use arrow keys to move")
		drawtext(0, 250, "space to punch")
		drawtext(0, 300, "ESC to quit")
		drawtext(0, 350, "use arrow keys to move")
		drawtext(0, 400, "press space to start")
		if keystate(control.punch) then
			oldtime = timerticks()
			state = "playing"
		end
	end
	
	if state == "playing" then
		drawimage (0,0,800,600,0,0,bg)	
		control.player()
		control.eny()
		Zorder()	
		drawActors()
		tensec()
		updateparticles()
		color(255,255,255)   
	end
	
	if state == "gameover" then
		drawtext(300, 200, "GAME OVER")
	end	
	sync()
end

closewindow()