function roundedbox (x1,y1,x2,y2,radius)
 fillbox (x1,y1,x2,y2)
 fillcircle (x1,y1,radius)
 fillcircle (x1,y2,radius)
 fillcircle (x2,y1,radius)
 fillcircle (x2,y2,radius)
 fillbox (x1,y1,x2,y1-radius)
 fillbox (x1,y1,x1-radius,y2)
 fillbox (x1,y2+radius,x2,y2)
 fillbox (x2,y1,x2+radius,y2)
end

function loadlevel (levelname)
bricksum = 0
row=1
level={}
mylevel = open ("data/brickmaster/level"..levelname..".dat","r")
repeat
	level[row]=finput (mylevel)
	row=row+1
until eof (mylevel)
close (mylevel)
newlevel={}
for i=1,row-1 do
	newlevel[i]={}
end
for i=1,row-1 do
	for j=1, 15 do
                newlevel [i][j]=asc(mid(level[i],j,1))
                if (asc(mid(level[i],j,1)) ~= 32) and (asc(mid(level[i],j,1)) ~= 88) then
                   bricksum = bricksum +1
                end
	end
   end
end

function drawlevel()
for i=1,row-1 do
	for j=1, 15 do
	    drawtile (42+j*42,18*2+i*18,(chr (newlevel [i][j])),bricks)
	end
    end
end

function menuscreen()

 start = false
 startzone = false
 quitzone = false
 cls()
 repeat

  key = getkey()


  putimage (0,0,background)
  bmptext (50,100,"B R I C K M A S T E R",charset)
  colour (255,255,0)
  drawtext (400,150,"Made with EGSL by Markus Mangold (C) 2012")

  colour (125,0,0)

  if mousezone (220-15,250-15,550+15,290+15) then
     colour (255,0,0)
     startzone = true
  end
  roundedbox (220,250,550,290,15)
  bmptext (220,250,"START GAME",charset)
  colour (125,0,0)

  if mousezone (220-15,350-15,550+15,390+15) then
     colour (255,0,0)
     quitzone = true
  end

  roundedbox (220,350,550,390,15)
  bmptext (230,350,"QUIT GAME",charset)

  bmptext (20,550,"TODAYS HISCORE: "..hiscore,charset)

  if (mouseb()== 1) and (startzone==true) then
    start = true
  end
   if (mouseb()== 1) and (quitzone==true) then
     closewindow()
     os.exit()
  end
  putimage (mousex(),mousey(),cursor)
  sync()
  startzone = false
  quitzone = false
  until (start == true)
  wait (1000)
end


screen (800,600,0,"Brickmaster")
setframetimer (80)
setparticlesize (8,"random")
setparticletype ("fillbox")
grabmouse()
mousehide()
colourkey (0,0,0)
charset = loadbmpfont ("data/brickmaster/Charset.png",5,10,"ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890?(),:.!-oabcde")
colourkey (255,0,255)
bricksound = loadsound ("data/brickmaster/bricksound.wav")
paddlesound = loadsound ("data/brickmaster/paddlesound.wav")
wallsound = loadsound ("data/brickmaster/wallsound.wav")
metallsound = loadsound ("data/brickmaster/metallsound.wav")
deadsound = loadsound ("data/brickmaster/dead.wav")
wall = loadimage ("data/brickmaster/bluewall.bmp")
background = loadimage ("data/brickmaster/background.png")
bricks = loadtileset ("data/brickmaster/bricks.png",9,2,"RrOoYyGgTtBbVvWwX ")
--' a brick is 42 x 18 pixels
cursor = loadimage ("data/brickmaster/bluepointer.png")

bat={}
bat.image=loadimage ("data/brickmaster/bat.png")
ball={}
ball.image=loadimage ("data/brickmaster/ballsmall.png")
hiscore = 0

repeat
score = 0
pads = 3
number=1
MAXLEVEL = 4
loadlevel (number)

bat.x=100
bat.y=500
ball.x=round (bat.x + imagewidth (bat.image)/2)
ball.y=round(bat.y - imageheight (ball.image)-1)
ball.normalx = 0
ball.normaly = 0
ball.dx=1
ball.dy=1
ball.speed=4

ballonbat = true

TILE_W=42
TILE_H=18
gridX=1
gridY=1
quit = false
backcolour (120,40,60)
   colour (255,255,0)

   menuscreen()

repeat
cls()
key=getkey()
bat.x= mousex()
if bat.x>= (screenwidth()-imagewidth(bat.image)-32) then
   bat.x=screenwidth()-imagewidth(bat.image)-32
end
if bat.x <=32 then
   bat.x=32
end
if mouseb()== 1 then
   ballonbat=false
end
if key == asc("c") then
   bricksum = 0
   --'CHEATER!
end

if ballonbat == true then
   ball.x = round (bat.x + imagewidth (bat.image)/2)
   ball.y = round(bat.y - imageheight (ball.image)-1)
else
    ball.x=round(ball.x+ball.dx*ball.speed)
    ball.y=round(ball.y+ball.dy*ball.speed)
end

if imagecoll (ball.image,ball.x,ball.y,bat.image,bat.x,bat.y) then
   playsound (paddlesound, 55,-1,0)
   dx = ball.x - round (bat.x + imagewidth (bat.image)/2)
     ball.y = round(bat.y - imageheight (ball.image))
   ball.dy=ball.dy*-1
   ball.dx=dx/64
   k = 1/sqrt (ball.dx * ball.dx + ball.dy * ball.dy)
   ball.dx = ball.dx * k
   ball.dy = ball.dy * k
end

if ball.x >= (screenwidth()-imagewidth(ball.image)-32) then
  playsound (bricksound, 100,-1,0)
   ball.dx=ball.dx*-1
end
if ball.x <= 32 then
     playsound (bricksound, 100,-1,0)
   ball.dx=ball.dx*-1
end
if ball.y <= 32 then
  playsound (bricksound, 100,-1,0)
   ball.dy=ball.dy*-1
end
if ball.y >= screenheight() then
   ballonbat=true
   playsound (deadsound, 150,-1,0)
   wait (1000)
   pads = pads - 1
end

ball.normalx =  round (ball.x - imagewidth (ball.image))

if ball.dy < 0 then
ball.normaly =  round (ball.y - (imageheight(ball.image)/2))
end
if ball.dy > 0 then
ball.normaly =  round (ball.y  )
end

gridX = round (ball.normalx /TILE_W)-1
gridY = round (ball.normaly /TILE_H)-2

--'now this is really not the right way to do it, like Mopz already said in his breakout tutorial -
--'but it worked best for me ...
if (gridX > 0) and (gridY > 0) and (gridY <=row-1) and (gridX <= 15) then
   if newlevel [gridY][gridX] ~= 32 then
      if newlevel[gridY][gridX] ~= 88 then
      playsound (wallsound,155,-1,0)
      if (newlevel[gridY][gridX])== 66 then  --'blue
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,5,180,200)
      end
      if (newlevel[gridY][gridX])== 87 then  --'white
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,200,200,200)
      end
      if (newlevel[gridY][gridX])== 79 then  --'orange
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,230,125,0)
      end
      if (newlevel[gridY][gridX])== 82 then   --'red
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,208,0,0)
      end
      if (newlevel[gridY][gridX])== 89 then   --'yellow
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,250,225,0)
      end
      if (newlevel[gridY][gridX])== 71 then   --'green
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,130,205,130)
      end
      if (newlevel[gridY][gridX])== 84 then   --'turqoise
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,0,220,220)
      end
      if (newlevel[gridY][gridX])== 86 then   --'violet
          createparticles ((42+gridX*42)+TILE_W/2,18*2+gridY*18,50,80,115,85,225)
      end


      newlevel [gridY][gridX] = 32
      bricksum = bricksum - 1
      score = score + 10
      else
      playsound (metallsound,155,-1,0)
      end
      prevGridX = round ((ball.normalx - ball.dx * ball.speed) / TILE_W)-1
      prevGridY = round ((ball.normaly - ball.dy * ball.speed) / TILE_H)-2
      if (prevGridX ~= gridX) and (prevGridY == gridY) then
         ball.dx = ball.dx * -1
      elseif (prevGridY ~= gridY) and (prevGridX == gridX) then
         ball.dy = ball.dy * -1
      else
         ball.dy = ball.dy * -1
         ball.dx = ball.dx * -1
      end
    end

end
putimage (0,0,background)

bmptext (50,550,"SCORE: "..score,charset)
bmptext (530,550,"PADS: "..pads,charset)

for i = 0,screenheight(),32 do
   putimage (0,i,wall)
   putimage (screenwidth()-32,i,wall)
end
for i = 0,screenwidth(),32 do
   putimage (i,0,wall)
end
drawlevel()

putimage (bat.x,bat.y,bat.image)
putimage (ball.x,ball.y,ball.image)
alphachannel (150)
updateparticles()
alphachannel (255)
if bricksum == 0 then
   number = number + 1
   if number > MAXLEVEL then
      number = 1
   end
   alphachannel (150)
   colour (0,0,0)
   fillbox (0,0,screenwidth(),screenheight())
   alphachannel (255)
   colour (0,0,255)
   roundedbox (150,250,660,290,15)
   bmptext (150,250,"LOADING LEVEL "..number,charset)
   resetparticles()
   sync()
   wait (1000)
   loadlevel (number)
   ballonbat = true
end

if key==asc ("f") then
   togglefullscreen()
end

if key ==asc("p") then
   releasemouse()
   mouseshow()
   alphachannel (150)
   colour (0,0,0)
   fillbox (0,0,screenwidth(),screenheight())
   alphachannel (255)
   colour (0,0,255)
   roundedbox (250,250,540,290,15)
   bmptext (250,250,"P A U S E",charset)
   sync()
   inkey()
   grabmouse()
   mousehide()
end
sync()
until (key==27) or (pads < 0)
alphachannel (150)
colour (0,0,0)
fillbox (0,0,screenwidth(),screenheight())
alphachannel (255)
colour (0,0,255)
roundedbox (250,250,540,290,15)
bmptext (250,250,"GAME OVER",charset)
   sync()
   wait (2000)
   if score > hiscore then
      hiscore = score
   end
until (quit == true)




