-- Going Deep
-- for LD26 
-- 2013 CFDT / Osgeld

-- window
openwindow (400,700,32,"Going Deep for LD 26 :: 2013 Osgeld")
colourkey(255,0,0) -- alpha key

-- resources
image = 
{
        player = loadimage("data/going_deep/player.png"),
        map        = loadimage("data/going_deep/map.png"),
        bg         = loadimage("data/going_deep/bg.png"), 
        jet = 
        {
                left   = loadimage("data/going_deep/left.png"),
                right  = loadimage("data/going_deep/right.png"),
                up     = loadimage("data/going_deep/fwd.png")
        }
}

sound = 
{
        explosion = loadsound("data/going_deep/explosion.wav"),
        pickup    = loadsound("data/going_deep/pickup.wav"),
        hit       = loadsound("data/going_deep/hit.wav"),
        music     = loadmusic("data/going_deep/music.it")
}

-- globals
gamestate = "title"

bg =
{
        red   = 255,
        green = 0,
        blue  = 0,
}

player =
{
        x       = 188,
        y       = 50,
        depth   = 0,
        energy  = 100,
        sheild  = 100,
        speed   = 3,
        workers = 0,
        onboard = 0,
        mom             = 0
}

workers =
{
        {300,200,0},
        {50,670,20},
        {316,754,20},
        {86,982,20},
        {200,1666,20},
        {40,2260,20},
        {100,2550,20},
}

-- constants
control = 
{
        up     = 273,
        down   = 274,
        left   = 276,
        right  = 275,
        escape = 027
}

playmusic(sound.music,100,-1)
-- main loop
while true do
        if gamestate == "playing" then
                --background
                for i = 1, 400, 10 do
                        drawimage (0,0,10,2625,i,player.depth * -1,image.bg)
                end
        
                -- draw map
                drawimage (0,0,400,2625,0,player.depth * -1,image.map)
        
                -- draw player
                putimage(player.x,player.y,image.player)
                
                -- draw workers
                circle(workers[1][1],workers[1][2] - player.depth,30)
                circle(workers[2][1],workers[2][2] - player.depth,30)
                circle(workers[3][1],workers[3][2] - player.depth,30)
                circle(workers[4][1],workers[4][2] - player.depth,30)
                circle(workers[5][1],workers[5][2] - player.depth,30)
                circle(workers[6][1],workers[6][2] - player.depth,30)
                circle(workers[7][1],workers[7][2] - player.depth,30)
                
                drawtext(workers[1][1],workers[1][2] - player.depth, player.workers)
                drawtext(workers[2][1],workers[2][2] - player.depth, workers[2][3])
                drawtext(workers[3][1],workers[3][2] - player.depth, workers[3][3])
                drawtext(workers[4][1],workers[4][2] - player.depth, workers[4][3])
                drawtext(workers[5][1],workers[5][2] - player.depth, workers[5][3])
                drawtext(workers[6][1],workers[6][2] - player.depth, workers[6][3])
                drawtext(workers[7][1],workers[7][2] - player.depth, workers[7][3])
                
                -- update workers
                if insidecircle(player.x + 12 , player.y + 12,workers[1][1],workers[1][2]- player.depth,30) then
                        if player.onboard > 0 then
                                player.workers = player.workers + player.onboard
                                player.onboard = 0
                                playsound(sound.pickup, 100, 1, 0)
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[2][1],workers[2][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[2][3] > 0 then
                                        workers[2][3] = workers[2][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[3][1],workers[3][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[3][3] > 0 then
                                        workers[3][3] = workers[3][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[4][1],workers[4][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[4][3] > 0 then
                                        workers[4][3] = workers[4][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[5][1],workers[5][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[5][3] > 0 then
                                        workers[5][3] = workers[5][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[6][1],workers[6][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[6][3] > 0 then
                                        workers[6][3] = workers[6][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                elseif insidecircle(player.x + 12 , player.y + 12,workers[7][1],workers[7][2]- player.depth,30) then 
                        if player.onboard == 0 then
                                if workers[7][3] > 0 then
                                        workers[7][3] = workers[7][3] - 10
                                        player.onboard = 10
                                        playsound(sound.pickup, 100, 1, 0)
                                end
                        end
                end
                
                -- next level
                if workers[2][3] == 0 and workers[3][3] == 0 and workers[4][3] == 0 and workers[5][3] == 0 and workers[6][3] == 0 and workers[7][3] == 0 then
                        print(player.workers % 120)
                        if player.workers % 120 == 0 then
                                workers[2][3] = 20
                                workers[3][3] = 20
                                workers[4][3] = 20
                                workers[5][3] = 20
                                workers[6][3] = 20
                                workers[7][3] = 20
                                player.speed = player.speed + 1
                        end
                end     
                
                        
                -- update player pos
                if player.depth < 2176 then
                        if player.y > 400 then player.depth = player.depth + player.speed
                        else player.y = player.y + player.speed
                        end
                end
        
                if player.mom == "L" then player.x = player.x - 0.50
                elseif player.mom == "R" then player.x = player.x + 0.50
                end
        
                -- controls
                if getkey() == control.escape  then break
                elseif  keystate(control.left) == true and player.energy > 0.5 then
                        putimage(player.x + 25,player.y +8,image.jet.left)
                        if player.x > 10 then 
                                player.x = player.x - player.speed
                                player.energy = player.energy - 0.1
                                player.mom = "L"
                        end
                elseif  keystate(control.right) == true and player.energy > 0.5 then
                        putimage(player.x - 11,player.y +8,image.jet.right)
                        if player.x < 390 then 
                                player.x = player.x + player.speed 
                                player.energy = player.energy - 0.1
                                player.mom = "R"
                        end
                end
                if keystate(control.up) == true and player.energy > 0.5 then
                        putimage(player.x + 8,player.y +25,image.jet.up)
                        if player.depth > - 400 then player.depth = player.depth - player.speed * 2 end
                        player.energy = player.energy - 0.1
                end
                if keystate(control.down) == true and player.energy > 0.5 then
                        putimage(player.x + 25,player.y +8,image.jet.left)
                        putimage(player.x - 11,player.y +8,image.jet.right)
                        player.energy = player.energy - 0.1
                        player.mom = "N"
                end 
        
                --landscape collision
                if imagered(player.x,player.depth + player.y,image.map) == 0 then
                        player.x = player.x + player.speed
                        player.depth = player.depth + player.speed * 3
                        playsound(sound.hit, 100, 1, 0)
                        player.sheild = player.sheild - 5
                        player.mom = "N"
                elseif imagered(player.x + 24,player.depth + player.y,image.map) == 0 then
                        player.x = player.x - player.speed
                        player.depth = player.depth + player.speed * 3
                        playsound(sound.hit, 100, 1, 0)
                        player.sheild = player.sheild - 5
                        player.mom = "N"
                elseif imagered(player.x + 24,(player.depth + player.y) + 24,image.map) == 0 then
                        player.x = player.x - player.speed
                        player.depth = player.depth - player.speed * 3
                        playsound(sound.hit, 100, 1, 0)
                        player.sheild = player.sheild - 5
                        player.mom = "N"
                elseif imagered(player.x,(player.depth + player.y) + 24,image.map) == 0 then
                        player.x = player.x + player.speed
                        player.depth = player.depth - player.speed * 3
                        playsound(sound.hit, 100, 1, 0)
                        player.sheild = player.sheild - 5
                        player.mom = "N"
                end
        
                -- update stats
                if player.sheild < 50 then colour (255,0,0) end
                drawtext(10,player.y - 50,"Shield: " .. player.sheild )
                if player.sheild < 1 then 
                        gamestate = "game over"
                end
        
                if player.energy < 50 then colour (255,0,0)
                else colour (255,255,255) end
                drawtext(10,player.y - 40,"Energy: " .. math.ceil(player.energy)) 
                colour (255,255,255)
                drawtext(10,player.y - 30,"Workers: " .. player.workers)
                
                if player.energy  < 99.1 then 
                        if keystate(control.left) == false and keystate(control.right) == false and keystate(control.up) == false and keystate(control.down) == false then
                                player.energy = player.energy + 0.25 
                        end                     
                end
                
        end -- gamestate playing
        
        if gamestate == "game over" then
                playsound(sound.explosion, 100, 1, 0)
                clearscreen() 
                gamestate = ("score")
        end
        
        if gamestate == "score" then
                colour (255,0,0) 
                drawtext(125,300,"G A M E  O V E R")
                colour (255,255,255) 
                drawtext(150,350,"Workers: " .. player.workers)
                if getkey() == control.escape  then break end           
        end
        
        if gamestate == "title" then
                colour (0,255,0) 
                drawtext(125,100,"     Going Deep")
                drawtext(125,120,"2013 Osgeld For LD26")
                colour (255,255,255)
                drawtext(110,200,"    USE ARROW KEYS")
                drawtext(110,220,"   COLLECT WORKERS")
                drawtext(110,240,"RETURN THEM TO HOME BASE")
                colour (255,0,0)
                drawtext(90,300,"WATCH YOUR SHEILD AND ENERGY")
                colour (255,255,255)
                drawtext(110,400,"PRESS ARROW KEY TO START")
                drawtext(110,420,"      ESC TO QUIT")
                local keypress = getkey()
                if keypress == control.escape  then break
                elseif keypress == control.up or keypress == control.down or keypress == control.left or keypress == control.right then
                        gamestate = "playing"
                end
        end
        
        sync()
end

closewindow()



